> For the complete documentation index, see [llms.txt](https://docs.algebra.finance/algebra-integral-documentation/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.algebra.finance/algebra-integral-documentation/algebra-v1-technical-reference/contracts/api-reference-v2.0-directional-fees/v2.0-directional-fees-core/ialgebrapooldeployer.md).

# IAlgebraPoolDeployer

An interface for a contract that is capable of deploying Algebra Pools

A contract that constructs a pool must implement this to pass arguments to the pool

*Developer note: This is used to avoid having constructor arguments in the pool contract, which results in the init code hash of the pool being constant allowing the CREATE2 address of the pool to be cheaply computed on-chain. Credit to Uniswap Labs under GPL-2.0-or-later license: <https://github.com/Uniswap/v3-core/tree/main/contracts/interfaces>*

## Functions

### getDeployParameters

`function getDeployParameters() external view returns (address dataStorage, address factory, address communityVault, address token0, address token1)` view external

Get the parameters to be used in constructing the pool, set transiently during pool creation. *Developer note: Called by the pool constructor to fetch the parameters of the pool*

**Returns:**

| Name           | Type    | Description                                        |
| -------------- | ------- | -------------------------------------------------- |
| dataStorage    | address | The pools associated dataStorage                   |
| factory        | address | The factory address                                |
| communityVault | address | The community vault address                        |
| token0         | address | The first token of the pool by address sort order  |
| token1         | address | The second token of the pool by address sort order |

### deploy

`function deploy(address dataStorage, address token0, address token1) external returns (address pool)` external

*Developer note: Deploys a pool with the given parameters by transiently setting the parameters in cache.*

| Name        | Type    | Description                                        |
| ----------- | ------- | -------------------------------------------------- |
| dataStorage | address | The pools associated dataStorage                   |
| token0      | address | The first token of the pool by address sort order  |
| token1      | address | The second token of the pool by address sort order |

**Returns:**

| Name | Type    | Description                 |
| ---- | ------- | --------------------------- |
| pool | address | The deployed pool's address |


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.algebra.finance/algebra-integral-documentation/algebra-v1-technical-reference/contracts/api-reference-v2.0-directional-fees/v2.0-directional-fees-core/ialgebrapooldeployer.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
